--- /dev/null	2019-07-14 19:11:50.000000000 +0000
+++ new/usr/src/cmd/sgs/common/leb128.c	2019-07-14 19:11:55.210896273 +0000
@@ -0,0 +1,328 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#include <stdio.h>
+#include <dwarf.h>
+#include <sys/types.h>
+#include <sys/elf.h>
+
+/*
+ * Little Endian Base 128 (LEB128) numbers.
+ * ----------------------------------------
+ *
+ * LEB128 is a scheme for encoding integers densely that exploits the
+ * assumption that most integers are small in magnitude. (This encoding
+ * is equally suitable whether the target machine architecture represents
+ * data in big-endian or little- endian
+ *
+ * Unsigned LEB128 numbers are encoded as follows: start at the low order
+ * end of an unsigned integer and chop it into 7-bit chunks. Place each
+ * chunk into the low order 7 bits of a byte. Typically, several of the
+ * high order bytes will be zero; discard them. Emit the remaining bytes in
+ * a stream, starting with the low order byte; set the high order bit on
+ * each byte except the last emitted byte. The high bit of zero on the last
+ * byte indicates to the decoder that it has encountered the last byte.
+ * The integer zero is a special case, consisting of a single zero byte.
+ *
+ * Signed, 2s complement LEB128 numbers are encoded in a similar except
+ * that the criterion for discarding high order bytes is not whether they
+ * are zero, but whether they consist entirely of sign extension bits.
+ * Consider the 32-bit integer -2. The three high level bytes of the number
+ * are sign extension, thus LEB128 would represent it as a single byte
+ * containing the low order 7 bits, with the high order bit cleared to
+ * indicate the end of the byte stream.
+ *
+ * Note that there is nothing within the LEB128 representation that
+ * indicates whether an encoded number is signed or unsigned. The decoder
+ * must know what type of number to expect.
+ *
+ * DWARF Exception Header Encoding
+ * -------------------------------
+ *
+ * The DWARF Exception Header Encoding is used to describe the type of data
+ * used in the .eh_frame_hdr section. The upper 4 bits indicate how the
+ * value is to be applied. The lower 4 bits indicate the format of the data.
+ *
+ * DWARF Exception Header value format
+ *
+ * Name		Value Meaning
+ * DW_EH_PE_omit	    0xff No value is present.
+ * DW_EH_PE_absptr	    0x00 Value is a void*
+ * DW_EH_PE_uleb128	    0x01 Unsigned value is encoded using the
+ *				 Little Endian Base 128 (LEB128)
+ * DW_EH_PE_udata2	    0x02 A 2 bytes unsigned value.
+ * DW_EH_PE_udata4	    0x03 A 4 bytes unsigned value.
+ * DW_EH_PE_udata8	    0x04 An 8 bytes unsigned value.
+ * DW_EH_PE_signed          0x08 bit on for all signed encodings
+ * DW_EH_PE_sleb128	    0x09 Signed value is encoded using the
+ *				 Little Endian Base 128 (LEB128)
+ * DW_EH_PE_sdata2	    0x0A A 2 bytes signed value.
+ * DW_EH_PE_sdata4	    0x0B A 4 bytes signed value.
+ * DW_EH_PE_sdata8	    0x0C An 8 bytes signed value.
+ *
+ * DWARF Exception Header application
+ *
+ * Name	    Value Meaning
+ * DW_EH_PE_absptr	   0x00 Value is used with no modification.
+ * DW_EH_PE_pcrel	   0x10 Value is reletive to the location of itself
+ * DW_EH_PE_textrel	   0x20
+ * DW_EH_PE_datarel	   0x30 Value is reletive to the beginning of the
+ *				eh_frame_hdr segment ( segment type
+ *			        PT_GNU_EH_FRAME )
+ * DW_EH_PE_funcrel        0x40
+ * DW_EH_PE_aligned        0x50 value is an aligned void*
+ * DW_EH_PE_indirect       0x80 bit to signal indirection after relocation
+ * DW_EH_PE_omit	   0xff No value is present.
+ *
+ */
+
+dwarf_error_t
+uleb_extract(unsigned char *data, uint64_t *dotp, size_t len, uint64_t *ret)
+{
+	uint64_t	dot = *dotp;
+	uint64_t	res = 0;
+	int		more = 1;
+	int		shift = 0;
+	int		val;
+
+	data += dot;
+
+	while (more) {
+		if (dot > len)
+			return (DW_OVERFLOW);
+
+		/*
+		 * Pull off lower 7 bits
+		 */
+		val = (*data) & 0x7f;
+
+		/*
+		 * Add prepend value to head of number.
+		 */
+		res = res | (val << shift);
+
+		/*
+		 * Increment shift & dot pointer
+		 */
+		shift += 7;
+		dot++;
+
+		/*
+		 * Check to see if hi bit is set - if not, this
+		 * is the last byte.
+		 */
+		more = ((*data++) & 0x80) >> 7;
+	}
+	*dotp = dot;
+	*ret = res;
+	return (DW_SUCCESS);
+}
+
+dwarf_error_t
+sleb_extract(unsigned char *data, uint64_t *dotp, size_t len, int64_t *ret)
+{
+	uint64_t	dot = *dotp;
+	int64_t		res = 0;
+	int		more = 1;
+	int		shift = 0;
+	int		val;
+
+	data += dot;
+
+	while (more) {
+		if (dot > len)
+			return (DW_OVERFLOW);
+
+		/*
+		 * Pull off lower 7 bits
+		 */
+		val = (*data) & 0x7f;
+
+		/*
+		 * Add prepend value to head of number.
+		 */
+		res = res | (val << shift);
+
+		/*
+		 * Increment shift & dot pointer
+		 */
+		shift += 7;
+		dot++;
+
+		/*
+		 * Check to see if hi bit is set - if not, this
+		 * is the last byte.
+		 */
+		more = ((*data++) & 0x80) >> 7;
+	}
+	*dotp = dot;
+
+	/*
+	 * Make sure value is properly sign extended.
+	 */
+	res = (res << (64 - shift)) >> (64 - shift);
+	*ret = res;
+	return (DW_SUCCESS);
+}
+
+/*
+ * Extract a DWARF encoded datum
+ *
+ * entry:
+ *	data - Base of data buffer containing encoded bytes
+ *	dotp - Address of variable containing index within data
+ *		at which the desired datum starts.
+ *	ehe_flags - DWARF encoding
+ *	eident - ELF header e_ident[] array for object being processed
+ *	frame_hdr - Boolean, true if we're extracting from .eh_frame_hdr
+ *	sh_base - Base address of ELF section containing desired datum
+ *	sh_offset - Offset relative to sh_base of desired datum.
+ *	dbase - The base address to which DW_EH_PE_datarel is relative
+ *		(if frame_hdr is false)
+ */
+dwarf_error_t
+dwarf_ehe_extract(unsigned char *data, size_t len, uint64_t *dotp,
+    uint64_t *ret, uint_t ehe_flags, unsigned char *eident,
+    boolean_t frame_hdr, uint64_t sh_base, uint64_t sh_offset,
+    uint64_t dbase)
+{
+	uint64_t    dot = *dotp;
+	uint_t	    lsb;
+	uint_t	    wordsize;
+	uint_t	    fsize;
+	uint64_t    result;
+
+	if (eident[EI_DATA] == ELFDATA2LSB)
+		lsb = 1;
+	else
+		lsb = 0;
+
+	if (eident[EI_CLASS] == ELFCLASS64)
+		wordsize = 8;
+	else
+		wordsize = 4;
+
+	switch (ehe_flags & 0x0f) {
+	case DW_EH_PE_omit:
+		*ret = 0;
+		return (DW_SUCCESS);
+	case DW_EH_PE_absptr:
+		fsize = wordsize;
+		break;
+	case DW_EH_PE_udata8:
+	case DW_EH_PE_sdata8:
+		fsize = 8;
+		break;
+	case DW_EH_PE_udata4:
+	case DW_EH_PE_sdata4:
+		fsize = 4;
+		break;
+	case DW_EH_PE_udata2:
+	case DW_EH_PE_sdata2:
+		fsize = 2;
+		break;
+	case DW_EH_PE_uleb128:
+		return (uleb_extract(data, dotp, len, ret));
+	case DW_EH_PE_sleb128:
+		return (sleb_extract(data, dotp, len, (int64_t *)ret));
+	default:
+		*ret = 0;
+		return (DW_BAD_ENCODING);
+	}
+
+	if (lsb) {
+		/*
+		 * Extract unaligned LSB formated data
+		 */
+		uint_t	cnt;
+
+		result = 0;
+		for (cnt = 0; cnt < fsize;
+		    cnt++, dot++) {
+			uint64_t val;
+
+			if (dot > len)
+				return (DW_OVERFLOW);
+			val = data[dot];
+			result |= val << (cnt * 8);
+		}
+	} else {
+		/*
+		 * Extract unaligned MSB formated data
+		 */
+		uint_t	cnt;
+		result = 0;
+		for (cnt = 0; cnt < fsize;
+		    cnt++, dot++) {
+			uint64_t val;
+
+			if (dot > len)
+				return (DW_OVERFLOW);
+			val = data[dot];
+			result |= val << ((fsize - cnt - 1) * 8);
+		}
+	}
+	/*
+	 * perform sign extension
+	 */
+	if ((ehe_flags & DW_EH_PE_signed) &&
+	    (fsize < sizeof (uint64_t))) {
+		int64_t	sresult;
+		uint_t	bitshift;
+		sresult = result;
+		bitshift = (sizeof (uint64_t) - fsize) * 8;
+		sresult = (sresult << bitshift) >> bitshift;
+		result = sresult;
+	}
+
+	/*
+	 * If value is relative to a base address, adjust it
+	 */
+	switch (ehe_flags & 0xf0) {
+	case DW_EH_PE_pcrel:
+		result += sh_base + sh_offset;
+		break;
+
+	/*
+	 * datarel is relative to .eh_frame_hdr if within .eh_frame,
+	 * but GOT if not.
+	 */
+	case DW_EH_PE_datarel:
+		if (frame_hdr)
+			result += sh_base;
+		else
+			result += dbase;
+		break;
+	}
+
+	/* Truncate the result to its specified size */
+	result = (result << ((sizeof (uint64_t) - fsize) * 8)) >>
+	    ((sizeof (uint64_t) - fsize) * 8);
+
+	*dotp = dot;
+	*ret = result;
+	return (DW_SUCCESS);
+}
--- /dev/null	2019-07-14 19:11:50.000000000 +0000
+++ new/usr/src/cmd/sgs/common/strhash.c	2019-07-14 19:11:55.432549888 +0000
@@ -0,0 +1,45 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2003 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#include <sgs.h>
+
+/*
+ * classic Bernstein k=33 hash function
+ *
+ * This routine is to be used for internal hashing of strings.  It's not
+ * to be confused with elf_hash() which is the required ELF hashing
+ * tool for ELF structures.
+ */
+uint_t
+sgs_str_hash(const char *str)
+{
+	uint_t	hash = 5381;
+	int		c;
+
+	while ((c = *str++) != 0)
+		hash = ((hash << 5) + hash) + c; /* hash * 33 + c */
+	return (hash);
+}
--- /dev/null	2019-07-14 19:11:50.000000000 +0000
+++ new/usr/src/cmd/sgs/common/string_table.c	2019-07-14 19:11:55.912225217 +0000
@@ -0,0 +1,684 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#include <_string_table.h>
+#include <strings.h>
+#include <sgs.h>
+#include <stdio.h>
+
+/*
+ * This file provides the interfaces to build a Str_tbl suitable for use by
+ * either the sgsmsg message system, or a standard ELF string table (SHT_STRTAB)
+ * as created by ld(1).
+ *
+ * There are two modes which can be used when constructing a string table:
+ *
+ *	st_new(0)
+ *		standard string table - no compression.  This is the
+ *		traditional, fast method.
+ *
+ *	st_new(FLG_STTAB_COMPRESS)
+ *		builds a compressed string table which both eliminates
+ *		duplicate strings, and permits strings with common suffixes
+ *		(atexit vs. exit) to overlap in the table.  This provides space
+ *		savings for many string tables.  Although more work than the
+ *		traditional method, the algorithms used are designed to scale
+ *		and keep any overhead at a minimum.
+ *
+ * These string tables are built with a common interface in a two-pass manner.
+ * The first pass finds all of the strings required for the string-table and
+ * calculates the size required for the final string table.
+ *
+ * The second pass allocates the string table, populates the strings into the
+ * table and returns the offsets the strings have been assigned.
+ *
+ * The calling sequence to build and populate a string table is:
+ *
+ *		st_new();		// initialize strtab
+ *
+ *		st_insert(st1);		// first pass of strings ...
+ *					// calculates size required for
+ *					// string table
+ *
+ *		st_delstring(st?);	// remove string previously
+ *					// inserted
+ *		st_insert(stN);
+ *
+ *		st_getstrtab_sz();	// freezes strtab and computes
+ *					// size of table.
+ *
+ *		st_setstrbuf();		// associates a final destination
+ *					// for the string table
+ *
+ *		st_setstring(st1);	// populate the string table
+ *		...			// offsets are based off of second
+ *					// pass	through the string table
+ *		st_setstring(stN);
+ *
+ *		st_destroy();		// tear down string table
+ *					// structures.
+ *
+ * String Suffix Compression Algorithm:
+ *
+ *   Here's a quick high level overview of the Suffix String
+ *   compression algorithm used.  First - the heart of the algorithm
+ *   is a Hash table list which represents a dictionary of all unique
+ *   strings inserted into the string table.  The hash function for
+ *   this table is a standard string hash except that the hash starts
+ *   at the last character in the string (&str[n - 1]) and works towards
+ *   the first character in the function (&str[0]).  As we compute the
+ *   HASH value for a given string, we also compute the hash values
+ *   for all of the possible suffix strings for that string.
+ *
+ *   As we compute the hash - at each character see if the current
+ *   suffix string for that hash is already present in the table.  If
+ *   it is, and the string is a master string.  Then change that
+ *   string to a suffix string of the new string being inserted.
+ *
+ *   When the final hash value is found (hash for str[0...n]), check
+ *   to see if it is in the hash table - if so increment the reference
+ *   count for the string.  If it is not yet in the table, insert a
+ *   new hash table entry for a master string.
+ *
+ *   The above method will find all suffixes of a given string given
+ *   that the strings are inserted from shortest to longest.  That is
+ *   why this is a two phase method, we first collect all of the
+ *   strings and store them based off of their length in an AVL tree.
+ *   Once all of the strings have been submitted we then start the
+ *   hash table build by traversing the AVL tree in order and
+ *   inserting the strings from shortest to longest as described
+ *   above.
+ */
+
+/* LINTLIBRARY */
+
+static int
+avl_len_compare(const void *n1, const void *n2)
+{
+	size_t	len1, len2;
+
+	len1 = ((LenNode *)n1)->ln_strlen;
+	len2 = ((LenNode *)n2)->ln_strlen;
+
+	if (len1 == len2)
+		return (0);
+	if (len2 < len1)
+		return (1);
+	return (-1);
+}
+
+static int
+avl_str_compare(const void *n1, const void *n2)
+{
+	const char	*str1, *str2;
+	int		rc;
+
+	str1 = ((StrNode *)n1)->sn_str;
+	str2 = ((StrNode *)n2)->sn_str;
+
+	rc = strcmp(str1, str2);
+	if (rc > 0)
+		return (1);
+	if (rc < 0)
+		return (-1);
+	return (0);
+}
+
+/*
+ * Return an initialized Str_tbl - returns NULL on failure.
+ *
+ * flags:
+ *	FLG_STTAB_COMPRESS - build a compressed string table
+ */
+Str_tbl *
+st_new(uint_t flags)
+{
+	Str_tbl	*stp;
+
+	if ((stp = calloc(sizeof (*stp), 1)) == NULL)
+		return (NULL);
+
+	/*
+	 * Start with a leading '\0' - it's tradition.
+	 */
+	stp->st_strsize = stp->st_fullstrsize = stp->st_nextoff = 1;
+
+	/*
+	 * Do we compress this string table?
+	 */
+	stp->st_flags = flags;
+	if ((stp->st_flags & FLG_STTAB_COMPRESS) == 0)
+		return (stp);
+
+	if ((stp->st_lentree = calloc(sizeof (*stp->st_lentree), 1)) == NULL)
+		return (NULL);
+
+	avl_create(stp->st_lentree, &avl_len_compare, sizeof (LenNode),
+	    SGSOFFSETOF(LenNode, ln_avlnode));
+
+	return (stp);
+}
+
+/*
+ * Insert a new string into the Str_tbl.  There are two AVL trees used.
+ *
+ *  -	The first LenNode AVL tree maintains a tree of nodes based on string
+ *	sizes.
+ *  -	Each LenNode maintains a StrNode AVL tree for each string.  Large
+ *	applications have been known to contribute thousands of strings of
+ *	the same size.  Should strings need to be removed (-z ignore), then
+ *	the string AVL tree makes this removal efficient and scalable.
+ */
+int
+st_insert(Str_tbl *stp, const char *str)
+{
+	size_t		len;
+	StrNode		*snp, sn = { 0 };
+	LenNode		*lnp, ln = { 0 };
+	avl_index_t	where;
+
+	/*
+	 * String table can't have been cooked
+	 */
+	assert((stp->st_flags & FLG_STTAB_COOKED) == 0);
+
+	/*
+	 * Null strings always point to the head of the string
+	 * table - no reason to keep searching.
+	 */
+	if ((len = strlen(str)) == 0)
+		return (0);
+
+	stp->st_fullstrsize += len + 1;
+	stp->st_strcnt++;
+
+	if ((stp->st_flags & FLG_STTAB_COMPRESS) == 0)
+		return (0);
+
+	/*
+	 * From the controlling string table, determine which LenNode AVL node
+	 * provides for this string length.  If the node doesn't exist, insert
+	 * a new node to represent this string length.
+	 */
+	ln.ln_strlen = len;
+	if ((lnp = avl_find(stp->st_lentree, &ln, &where)) == NULL) {
+		if ((lnp = calloc(sizeof (*lnp), 1)) == NULL)
+			return (-1);
+		lnp->ln_strlen = len;
+		avl_insert(stp->st_lentree, lnp, where);
+
+		if ((lnp->ln_strtree = calloc(sizeof (*lnp->ln_strtree), 1)) ==
+		    NULL)
+			return (0);
+
+		avl_create(lnp->ln_strtree, &avl_str_compare, sizeof (StrNode),
+		    SGSOFFSETOF(StrNode, sn_avlnode));
+	}
+
+	/*
+	 * From the string length AVL node determine whether a StrNode AVL node
+	 * provides this string.  If the node doesn't exist, insert a new node
+	 * to represent this string.
+	 */
+	sn.sn_str = str;
+	if ((snp = avl_find(lnp->ln_strtree, &sn, &where)) == NULL) {
+		if ((snp = calloc(sizeof (*snp), 1)) == NULL)
+			return (-1);
+		snp->sn_str = str;
+		avl_insert(lnp->ln_strtree, snp, where);
+	}
+	snp->sn_refcnt++;
+
+	return (0);
+}
+
+/*
+ * Remove a previously inserted string from the Str_tbl.
+ */
+int
+st_delstring(Str_tbl *stp, const char *str)
+{
+	size_t		len;
+	LenNode		*lnp, ln = { 0 };
+	StrNode		*snp, sn = { 0 };
+
+	/*
+	 * String table can't have been cooked
+	 */
+	assert((stp->st_flags & FLG_STTAB_COOKED) == 0);
+
+	len = strlen(str);
+	stp->st_fullstrsize -= len + 1;
+
+	if ((stp->st_flags & FLG_STTAB_COMPRESS) == 0)
+		return (0);
+
+	/*
+	 * Determine which LenNode AVL node provides for this string length.
+	 */
+	ln.ln_strlen = len;
+	if ((lnp = avl_find(stp->st_lentree, &ln, 0)) != NULL) {
+		sn.sn_str = str;
+		if ((snp = avl_find(lnp->ln_strtree, &sn, 0)) != NULL) {
+			/*
+			 * Reduce the reference count, and if zero remove the
+			 * node.
+			 */
+			if (--snp->sn_refcnt == 0)
+				avl_remove(lnp->ln_strtree, snp);
+			return (0);
+		}
+	}
+
+	/*
+	 * No strings of this length, or no string itself - someone goofed.
+	 */
+	return (-1);
+}
+
+/*
+ * Tear down a String_Table structure.
+ */
+void
+st_destroy(Str_tbl *stp)
+{
+	Str_hash	*sthash, *psthash;
+	Str_master	*mstr, *pmstr;
+	uint_t		i;
+
+	/*
+	 * cleanup the master strings
+	 */
+	for (mstr = stp->st_mstrlist, pmstr = 0; mstr;
+	    mstr = mstr->sm_next) {
+		if (pmstr)
+			free(pmstr);
+		pmstr = mstr;
+	}
+	if (pmstr)
+		free(pmstr);
+
+	if (stp->st_hashbcks) {
+		for (i = 0; i < stp->st_hbckcnt; i++) {
+			for (sthash = stp->st_hashbcks[i], psthash = 0;
+			    sthash; sthash = sthash->hi_next) {
+				if (psthash)
+					free(psthash);
+				psthash = sthash;
+			}
+			if (psthash)
+				free(psthash);
+		}
+		free(stp->st_hashbcks);
+	}
+	free(stp);
+}
+
+
+/*
+ * For a given string - copy it into the buffer associated with
+ * the string table - and return the offset it has been assigned.
+ *
+ * If a value of '-1' is returned - the string was not found in
+ * the Str_tbl.
+ */
+int
+st_setstring(Str_tbl *stp, const char *str, size_t *stoff)
+{
+	size_t		stlen;
+	uint_t		hashval;
+	Str_hash	*sthash;
+	Str_master	*mstr;
+	int		i;
+
+	/*
+	 * String table *must* have been previously cooked
+	 */
+	assert(stp->st_strbuf);
+
+	assert(stp->st_flags & FLG_STTAB_COOKED);
+	stlen = strlen(str);
+	/*
+	 * Null string always points to head of string table
+	 */
+	if (stlen == 0) {
+		*stoff = 0;
+		return (0);
+	}
+
+	if ((stp->st_flags & FLG_STTAB_COMPRESS) == 0) {
+		size_t		_stoff;
+
+		stlen++;	/* count for trailing '\0' */
+		_stoff = stp->st_nextoff;
+		/*
+		 * Have we overflowed our assigned buffer?
+		 */
+		if ((_stoff + stlen) > stp->st_fullstrsize)
+			return (-1);
+		memcpy(stp->st_strbuf + _stoff, str, stlen);
+		*stoff = _stoff;
+		stp->st_nextoff += stlen;
+		return (0);
+	}
+
+	/*
+	 * Calculate reverse hash for string.
+	 */
+	hashval = HASHSEED;
+	for (i = stlen; i >= 0; i--) {
+		hashval = ((hashval << 5) + hashval) +
+		    str[i];			/* h = ((h * 33) + c) */
+	}
+
+	for (sthash = stp->st_hashbcks[hashval % stp->st_hbckcnt]; sthash;
+	    sthash = sthash->hi_next) {
+		const char	*hstr;
+
+		if (sthash->hi_hashval != hashval)
+			continue;
+
+		hstr = &sthash->hi_mstr->sm_str[sthash->hi_mstr->sm_strlen -
+		    sthash->hi_strlen];
+		if (strcmp(str, hstr) == 0)
+			break;
+	}
+
+	/*
+	 * Did we find the string?
+	 */
+	if (sthash == 0)
+		return (-1);
+
+	/*
+	 * Has this string been copied into the string table?
+	 */
+	mstr = sthash->hi_mstr;
+	if (mstr->sm_stroff == 0) {
+		size_t	mstrlen = mstr->sm_strlen + 1;
+
+		mstr->sm_stroff = stp->st_nextoff;
+
+		/*
+		 * Have we overflowed our assigned buffer?
+		 */
+		if ((mstr->sm_stroff + mstrlen) > stp->st_fullstrsize)
+			return (-1);
+
+		(void) memcpy(stp->st_strbuf + mstr->sm_stroff,
+		    mstr->sm_str, mstrlen);
+		stp->st_nextoff += mstrlen;
+	}
+
+	/*
+	 * Calculate offset of (sub)string.
+	 */
+	*stoff = mstr->sm_stroff + mstr->sm_strlen - sthash->hi_strlen;
+
+	return (0);
+}
+
+
+static int
+st_hash_insert(Str_tbl *stp, const char *str, size_t len)
+{
+	int		i;
+	uint_t		hashval = HASHSEED;
+	uint_t		bckcnt = stp->st_hbckcnt;
+	Str_hash	**hashbcks = stp->st_hashbcks;
+	Str_hash	*sthash;
+	Str_master	*mstr = 0;
+
+	/*
+	 * We use a classic 'Bernstein k=33' hash function.  But
+	 * instead of hashing from the start of the string to the
+	 * end, we do it in reverse.
+	 *
+	 * This way - we are essentially building all of the
+	 * suffix hashvalues as we go.  We can check to see if
+	 * any suffixes already exist in the tree as we generate
+	 * the hash.
+	 */
+	for (i = len; i >= 0; i--) {
+		hashval = ((hashval << 5) + hashval) +
+		    str[i];			/* h = ((h * 33) + c) */
+
+		for (sthash = hashbcks[hashval % bckcnt];
+		    sthash; sthash = sthash->hi_next) {
+			const char	*hstr;
+			Str_master	*_mstr;
+
+			if (sthash->hi_hashval != hashval)
+				continue;
+
+			_mstr = sthash->hi_mstr;
+			hstr = &_mstr->sm_str[_mstr->sm_strlen -
+			    sthash->hi_strlen];
+
+			if (strcmp(&str[i], hstr))
+				continue;
+
+			if (i == 0) {
+				/*
+				 * Entry already in table, increment refcnt and
+				 * get out.
+				 */
+				sthash->hi_refcnt++;
+				return (0);
+			} else {
+				/*
+				 * If this 'suffix' is presently a 'master
+				 * string, then take over it's record.
+				 */
+				if (sthash->hi_strlen == _mstr->sm_strlen) {
+					/*
+					 * we should only do this once.
+					 */
+					assert(mstr == 0);
+					mstr = _mstr;
+				}
+			}
+		}
+	}
+
+	/*
+	 * Do we need a new master string, or can we take over
+	 * one we already found in the table?
+	 */
+	if (mstr == 0) {
+		/*
+		 * allocate a new master string
+		 */
+		if ((mstr = calloc(sizeof (*mstr), 1)) == 0)
+			return (-1);
+		mstr->sm_next = stp->st_mstrlist;
+		stp->st_mstrlist = mstr;
+		stp->st_strsize += len + 1;
+	} else {
+		/*
+		 * We are taking over a existing master string, the string size
+		 * only increments by the difference between the current string
+		 * and the previous master.
+		 */
+		assert(len > mstr->sm_strlen);
+		stp->st_strsize += len - mstr->sm_strlen;
+	}
+
+	if ((sthash = calloc(sizeof (*sthash), 1)) == 0)
+		return (-1);
+
+	mstr->sm_hashval = sthash->hi_hashval = hashval;
+	mstr->sm_strlen = sthash->hi_strlen = len;
+	mstr->sm_str = str;
+	sthash->hi_refcnt = 1;
+	sthash->hi_mstr = mstr;
+
+	/*
+	 * Insert string element into head of hash list
+	 */
+	hashval = hashval % bckcnt;
+	sthash->hi_next = hashbcks[hashval];
+	hashbcks[hashval] = sthash;
+	return (0);
+}
+
+/*
+ * Return amount of space required for the string table.
+ */
+size_t
+st_getstrtab_sz(Str_tbl *stp)
+{
+	assert(stp->st_fullstrsize > 0);
+
+	if ((stp->st_flags & FLG_STTAB_COMPRESS) == 0) {
+		stp->st_flags |= FLG_STTAB_COOKED;
+		return (stp->st_fullstrsize);
+	}
+
+	if ((stp->st_flags & FLG_STTAB_COOKED) == 0) {
+		LenNode		*lnp;
+		void		*cookie;
+
+		stp->st_flags |= FLG_STTAB_COOKED;
+		/*
+		 * allocate a hash table about the size of # of
+		 * strings input.
+		 */
+		stp->st_hbckcnt = findprime(stp->st_strcnt);
+		if ((stp->st_hashbcks = calloc(sizeof (*stp->st_hashbcks),
+		    stp->st_hbckcnt)) == NULL)
+			return (0);
+
+		/*
+		 * We now walk all of the strings in the list, from shortest to
+		 * longest, and insert them into the hashtable.
+		 */
+		if ((lnp = avl_first(stp->st_lentree)) == NULL) {
+			/*
+			 * Is it possible we have an empty string table, if so,
+			 * the table still contains '\0', so return the size.
+			 */
+			if (avl_numnodes(stp->st_lentree) == 0) {
+				assert(stp->st_strsize == 1);
+				return (stp->st_strsize);
+			}
+			return (0);
+		}
+
+		while (lnp) {
+			StrNode	*snp;
+
+			/*
+			 * Walk the string lists and insert them into the hash
+			 * list.  Once a string is inserted we no longer need
+			 * it's entry, so the string can be freed.
+			 */
+			for (snp = avl_first(lnp->ln_strtree); snp;
+			    snp = AVL_NEXT(lnp->ln_strtree, snp)) {
+				if (st_hash_insert(stp, snp->sn_str,
+				    lnp->ln_strlen) == -1)
+					return (0);
+			}
+
+			/*
+			 * Now that the strings have been copied, walk the
+			 * StrNode tree and free all the AVL nodes.  Note,
+			 * avl_destroy_nodes() beats avl_remove() as the
+			 * latter balances the nodes as they are removed.
+			 * We just want to tear the whole thing down fast.
+			 */
+			cookie = NULL;
+			while ((snp = avl_destroy_nodes(lnp->ln_strtree,
+			    &cookie)) != NULL)
+				free(snp);
+			avl_destroy(lnp->ln_strtree);
+			free(lnp->ln_strtree);
+			lnp->ln_strtree = NULL;
+
+			/*
+			 * Move on to the next LenNode.
+			 */
+			lnp = AVL_NEXT(stp->st_lentree, lnp);
+		}
+
+		/*
+		 * Now that all of the strings have been freed, walk the
+		 * LenNode tree and free all of the AVL nodes.  Note,
+		 * avl_destroy_nodes() beats avl_remove() as the latter
+		 * balances the nodes as they are removed. We just want to
+		 * tear the whole thing down fast.
+		 */
+		cookie = NULL;
+		while ((lnp = avl_destroy_nodes(stp->st_lentree,
+		    &cookie)) != NULL)
+			free(lnp);
+		avl_destroy(stp->st_lentree);
+		free(stp->st_lentree);
+		stp->st_lentree = 0;
+	}
+
+	assert(stp->st_strsize > 0);
+	assert(stp->st_fullstrsize >= stp->st_strsize);
+
+	return (stp->st_strsize);
+}
+
+/*
+ * Associate a buffer with a string table.
+ */
+const char *
+st_getstrbuf(Str_tbl *stp)
+{
+	return (stp->st_strbuf);
+}
+
+int
+st_setstrbuf(Str_tbl *stp, char *stbuf, size_t bufsize)
+{
+	assert(stp->st_flags & FLG_STTAB_COOKED);
+
+	if ((stp->st_flags & FLG_STTAB_COMPRESS) == 0) {
+		if (bufsize < stp->st_fullstrsize)
+			return (-1);
+	} else {
+		if (bufsize < stp->st_strsize)
+			return (-1);
+	}
+
+	stp->st_strbuf = stbuf;
+#ifdef	DEBUG
+	/*
+	 * for debug builds - start with a stringtable filled in
+	 * with '0xff'.  This makes it very easy to spot unfilled
+	 * holes in the strtab.
+	 */
+	memset(stbuf, 0xff, bufsize);
+	stbuf[0] = '\0';
+#else
+	memset(stbuf, 0x0, bufsize);
+#endif
+	return (0);
+}
--- old/usr/src/cmd/sgs/crle/Makefile.com	2019-07-14 19:11:56.120561849 +0000
+++ new/usr/src/cmd/sgs/crle/Makefile.com	2019-07-14 19:11:56.137082632 +0000
@@ -35,9 +35,9 @@
 COMOBJ=		config.o	crle.o		depend.o	dump.o \
 		inspect.o	hash.o		print.o		util.o
 BLTOBJ=		msg.o
-TOOLSOBJ=	alist.o
+SGSCOMMONOBJ=	alist.o
 
-OBJS=		$(BLTOBJ) $(COMOBJ) $(TOOLSOBJ)
+OBJS=		$(BLTOBJ) $(COMOBJ) $(SGSCOMMONOBJ)
 
 MAPFILE=	$(MAPFILE.NGB)
 MAPOPT=		$(MAPFILE:%=-M%)
@@ -45,13 +45,12 @@
 # not linted
 SMATCH=off
 
-CPPFLAGS +=	-I$(SRC)/common/sgsrtcid -I$(SRCBASE)/uts/$(ARCH)/sys \
+CPPFLAGS +=	-I$(SRC)/common/sgsrtcid -I$(SRC)/uts/$(ARCH)/sys \
 		-D__EXTENSIONS__
 LLDFLAGS =	'-R$$ORIGIN/../lib'
 LLDFLAGS64 =	'-R$$ORIGIN/../../lib/$(MACH64)'
-LDFLAGS +=	$(VERSREF) $(CC_USE_PROTO) $(MAPOPT) \
-			$(LLDFLAGS) $(ZNOLAZYLOAD)
-LDLIBS +=	-lelf $(CONVLIBDIR) $(CONV_LIB) $(DLLIB)
+LDFLAGS +=	$(VERSREF) $(MAPOPT) $(LLDFLAGS) $(ZNOLAZYLOAD)
+LDLIBS +=	-lelf $(CONVLIBDIR) -lconv
 
 BLTDEFS=        msg.h
 BLTDATA=        msg.c
@@ -66,6 +65,6 @@
 SGSMSGFLAGS +=	-h $(BLTDEFS) -d $(BLTDATA) -m $(BLTMESG) -n crle_msg
 
 SRCS=		$(COMOBJ:%.o=../common/%.c) $(BLTDATA) \
-		$(TOOLSOBJ:%.o=$(SGSTOOLS)/common/%.c)
+		$(COMMON:%.o=$(SGSCOMMON)/%.c)
 
 CLEANFILES +=	$(BLTFILES)
--- old/usr/src/cmd/sgs/crle/Makefile.targ	2019-07-14 19:11:56.572342828 +0000
+++ new/usr/src/cmd/sgs/crle/Makefile.targ	2019-07-14 19:11:56.588889408 +0000
@@ -28,7 +28,7 @@
 		$(COMPILE.c) $<
 		$(POST_PROCESS_O)
 
-%.o:            $(SGSTOOLS)/common/%.c
+%.o:            $(SGSCOMMON)/%.c
 		$(COMPILE.c) $<
 		$(POST_PROCESS_O)
 
--- old/usr/src/cmd/sgs/dump/Makefile.com	2019-07-14 19:11:57.009691544 +0000
+++ new/usr/src/cmd/sgs/dump/Makefile.com	2019-07-14 19:11:57.025839984 +0000
@@ -48,4 +48,4 @@
 
 SMOFF += indenting
 
-LDLIBS +=	$(CONVLIBDIR) $(CONV_LIB) $(ELFLIBDIR) -lelf
+LDLIBS +=	$(CONVLIBDIR) -lconv $(ELFLIBDIR) -lelf
--- old/usr/src/cmd/sgs/elfdump/Makefile.com	2019-07-14 19:11:57.444088854 +0000
+++ new/usr/src/cmd/sgs/elfdump/Makefile.com	2019-07-14 19:11:57.460670012 +0000
@@ -39,23 +39,23 @@
 
 COMOBJ64 =	elfdump64.o fake_shdr64.o
 
-TOOLOBJ =	leb128.o
+SGSCOMMONOBJ =	leb128.o
 
 BLTOBJ =	msg.o
 
-OBJS=		$(BLTOBJ) $(COMOBJ) $(COMOBJ32) $(COMOBJ64) $(TOOLOBJ)
+OBJS=		$(BLTOBJ) $(COMOBJ) $(COMOBJ32) $(COMOBJ64) $(SGSCOMMONOBJ)
 
 MAPFILE=	$(MAPFILE.NGB)
 MAPOPT=		$(MAPFILE:%=-M%)
 
 CPPFLAGS=	-I. -I../common -I../../include -I../../include/$(MACH) \
-		-I$(SRCBASE)/lib/libc/inc -I$(SRCBASE)/uts/$(ARCH)/sys \
+		-I$(SRC)/lib/libc/inc -I$(SRC)/uts/$(ARCH)/sys \
 		$(CPPFLAGS.master) -I$(ELFCAP)
 LLDFLAGS =	$(VAR_ELFDUMP_LLDFLAGS)
 LLDFLAGS64 =	$(VAR_ELFDUMP_LLDFLAGS64)
-LDFLAGS +=	$(VERSREF) $(CC_USE_PROTO) $(MAPOPT) $(LLDFLAGS)
-LDLIBS +=	$(ELFLIBDIR) -lelf $(LDDBGLIBDIR) $(LDDBG_LIB) \
-		    $(CONVLIBDIR) $(CONV_LIB)
+LDFLAGS +=	$(VERSREF) $(MAPOPT) $(LLDFLAGS)
+LDLIBS +=	$(ELFLIBDIR) -lelf $(LDDBGLIBDIR) -llddbg \
+		    $(CONVLIBDIR) -lconv
 
 CERRWARN +=	-_gcc=-Wno-uninitialized
 
@@ -75,6 +75,6 @@
 
 SRCS =		$(COMOBJ:%.o=../common/%.c) \
 		$(COMOBJ32:%32.o=../common/%.c) \
-		$(TOOLOBJ:%.o=../../tools/common/%.c) $(BLTDATA)
+		$(SGSCOMMONOBJ:%.o=$(SGSCOMMON)/%.c) $(BLTDATA)
 
 CLEANFILES +=	$(BLTFILES) gen_struct_layout
